from ScrumPy.Bioinf import Biomass
from ScrumPy.Util import Set

from importlib import reload


#
##
### Assumed composition of E. coli (from Sisse)
##
#

reload(Biomass)


#
## TODO: Check if extra MolWts still needed and put them in ExtraCompounds.dat
#

Biomass.MolWts.MolWts["ASPARTATE"] = 133.11
Biomass.MolWts.MolWts["Starch"] = 180.1559
Biomass.MolWts.MolWts["Peptidoglycan"] = 1010.018 #Peptidoglycan monomer from https://pubchem.ncbi.nlm.nih.gov/compound/3035036
Biomass.MolWts.MolWts["CDPdag"] = 1002.13 #CDPdag/CDP-diacylglycerol: https://pubchem.ncbi.nlm.nih.gov/compound/91666376
Biomass.MolWts.MolWts["PA"] = 679.888
Biomass.MolWts.MolWts["PS"] = 786.03
Biomass.MolWts.MolWts["PE"] = 742.02
Biomass.MolWts.MolWts["PG"] = 773.031
Biomass.MolWts.MolWts["UDP-GLUCOSE"] = 564.289
Biomass.MolWts.MolWts["UDP-GALACTOSE"] = 564.289
Biomass.MolWts.MolWts["LPS"] = 4063.424
Biomass.MolWts.MolWts["CLPN"] = 1453.968



prot = Biomass.Composition(
    0.563,{
"TYR" : 0.026,
"GLT" : 0.049,
"LYS" : 0.064,
"VAL" : 0.026,
"PHE" : 0.035,
"GLN" : 0.049,
"THR" : 0.047,
"MET" : 0.029,
"TRP" : 0.011,
"SER" : 0.040,
"GLY" : 0.115,
"HIS" : 0.018,
"LEU" : 0.084,
"CYS" : 0.017,
"L-ASPARTATE" : 0.045,
"ILE" : 0.054,
"L-ALPHA-ALANINE" : 0.096,
"ASN" : 0.045,
"ARG" : 0.055,
"PRO" : 0.041 
        }
    )


DNAnuc = Biomass.Composition(
    0.031,{
"DATP" : 0.266,
"DCTP" : 0.254,
"DGTP" : 0.254,
"TTP" : 0.246
		}
	)

RNAnuc = Biomass.Composition(
    0.21,{
"CTP" : 0.200,
"UTP" : 0.216,
"GTP" : 0.322,
"ATP" : 0.262
        }
    )

cellwall =  Biomass.Composition(
    0.025,{
        "Peptidoglycan" : 0.5,
        "LPS": 0.5
        }
    )

starch =    Biomass.Composition(
    0.025,
    {
         "Starch": 1
    }
)

cellmembrane = Biomass.Composition(
    0.093,{
        "PA" : 0.2375,
        "PE" : 0.2375,
        "PG" : 0.2375,
        "PS" : 0.2375,
        "CLPN" : 0.05
        }
    )


##lipid = Biomass.Composition(
##    0.093, {
##        "PALMITATE":1.0
##        }
##    )


sol = Biomass.Composition(
    0.027, {
	"PUTRESCINE" : 0.7607982647,
        "SPERMIDINE" : 0.1542216427,
        "5-METHYL-THF" : 0.0153209301,
        "ACETYL-COA" : 0.0063837209,
        #"CO-A" : 0.0038302325,
        "SUC-COA" : 0.0022470697,
        #"FAD" : 0.0051069767,
        "NAD" : 0.0408558136,
        "NADH" : 0.0010213953,
        "NADP" : 0.0025534883,
        "NADPH" : 0.007660465
        
##   "SUCROSE_Cyto": 0.75,
##   "GLC_Cyto": 0.25
    }
)

##lps = Biomass.Composition(
##    0.034, {
##        "LPS":1.0
##        }
##    )


All = Biomass.Composition(
    1.0, 
    {
        "starch": starch,
        "prot" : prot,
        "DNAnuc" : DNAnuc,
	"RNAnuc" : RNAnuc,
        "cellwall" : cellwall,
        "cellmembrane" : cellmembrane,
        #"lipid":lipid,
        "sol" : sol,
        #"lps" : lps
    }
)




#
## TODO: Check that these are now in ScrumPy itself
#

StripComp = lambda s: s.rsplit("_",1)[0]

def FluxDic(model):
    rv = {}
    for met in All.GetLeaves():
        xp = WhatExports(model,met)

        if xp == None:
            print ("no tx for ", met)
        else:
            rv[xp] = -All.MolsOf(met,StripComp)
    return rv

def WhatExports(m, compound):
    

    Externs = m.md.GetExtMetNames()

    for reac in m.sm.InvolvedWith(compound).keys():
        if "bm_tx" in reac and len(Set.Intersect(Externs, m.smx.InvolvedWith(reac).keys())) != 0:
            return reac
